/* Copyright (C) 1996-1999 PLUS Group - University of Maryland

   This software is provided under the terms of the GNU General Public
   License Version 2, June 1991. See the file License.html for details.
   */
package parka;

import  java.io.*;

public class  Command extends java.lang.Object
{
    // PARKA command list:
    //
//  (Note: calls not implemented in class responsible for socket connection
//  are marked for convenience.  Doesn't matter to this class tho.)

    static final String  OPENKB        = "10001";
    static final String  CLOSEKB       = "10002";
    static final String  QUERY         = "10003";
    static final String  GETBINDINGS   = "10004";
    static final String  GETPREDICATES = "10005";
    static final String  GETFRAMENAME  = "10006";   //not implemented
    static final String  GETFRAMEID    = "10007";   //not implemented
    static final String  TOGGLE        = "10008";   //not implemented
    static final String  PARKACONFIG   = "10009";
    static final String  GETKBNAMES    = "10010";
    static final String  GETTIMINGS    = "10011";
    static final String  GETVARIABLES  = "10012";
    // Not implemented:
    static final String  INSERTTOKB    = "10013";  //  <== adding assertions
    static final String  DELETEFROMKB  = "10014";  //  <== deleting assertions
    static final String  INSERTFRAME   = "10015";  //  <== adding frames only
    static final String  DELETEFRAME   = "10016";  //  <== deleting frames,
                              //  and assertions on them
    static final String  JBROWSERQUERY = "10017";  // info for Java browser
    static final String  JBRWQUERYCONT = "10018";  // JBROWSERQUERY was not
        //able to get all info for Java browser, since communication buffer
	//of server was filled.  Get rest(more) of data.
    static final String  DISCONNECT    = "close";
	//close socket connection from client
	//Response class not used after this one (no response is there).

    int     sizeOfCmd;
    String  sizeOfCmdStr;
    String  cmdStr;
    OutputStream   outstream;

    Command (ParkaNet pn, String cmd, String arglist)
    {
        if (arglist.length() > 0)
	    cmdStr = cmd + " " + arglist;
	else
	    cmdStr = cmd;
	sizeOfCmd = cmdStr.length();
	sizeOfCmdStr = String.valueOf(sizeOfCmd) + " ";
	outstream = pn.getOutStream();
    }

    // Send command to PARKA.
    // It is the user's responsibility to have already set up the
    // communication channels before calling this routine.
    //
    void sendCommand()
    {
        // convert to byte array
        String tmpstr = sizeOfCmdStr + cmdStr;
        byte cmd[]    = new byte[tmpstr.length()];
        tmpstr.getBytes(0, tmpstr.length(), cmd, 0);

        try
        {
/* TEST
            System.out.println(tmpstr);
*/
            // Write to output stream
            outstream.write (cmd, 0, tmpstr.length());
	        //args: byte array to write from; offset; length.
            outstream.flush();
        }
        catch (IOException e1)
        {
            System.out.println("IO Error in sendCommand");
            System.out.println("   Command is " + cmdStr);
        }
    }
}
