/* Copyright (C) 1996-1999 PLUS Group - University of Maryland

   This software is provided under the terms of the GNU General Public
   License Version 2, June 1991. See the file License.html for details.
   */
package parka;

import java.awt.*;
import java.util.*;

/*  Class to create generic Menus
 */

public class  MenuMaker  extends java.lang.Object
{
    private String     menuName;
    private String[]   menuItemNames;
    private int[]      separatorPositions;
    private Vector[]   checkboxMIgroups;  //Array of Vectors;
                          //items are Vectors from CheckboxMenuItemGroup class
    static final int  SIMPLE = 1;
    static final int  CHKBOX = 2;
    static final int  CHKBOXGROUP = 3;
    private int      menuCreateType;
    private int      sepPosListPosition;

    MenuMaker (String mName, int menuType, String[] nameList, int[] sepPosList)
    {
	menuName = mName;
	menuItemNames = nameList;
	separatorPositions = sepPosList;
	menuCreateType = menuType;
	if ((separatorPositions != null) && (separatorPositions.length > 0))
	    sepPosListPosition = 0;
	else
	    sepPosListPosition = -1; //no separators to add to menu
    }

    MenuMaker (String mName, Vector[] checkboxVectorList)
    {
	menuName = mName;
	checkboxMIgroups = checkboxVectorList;
	menuCreateType = CHKBOXGROUP;
    }

    Menu createMenu()
    {
	Menu   m;

	switch (menuCreateType)
	{
	  case SIMPLE:
		m = createSimpleMenu();
		break;
          case CHKBOX:
		m = createCheckboxMenu();
		break;
	  case CHKBOXGROUP:
		m = createCheckboxGroupMenu();
		break;
	  default:
		m = null;
		System.out.println ("Not a valid menu type");
		break;
	}
	return   m;
    }

    private Menu createSimpleMenu()
    {
	Menu   m;

	m = new Menu (menuName);
	for (int i = 0; i < menuItemNames.length; i++)
	{
	    m.add (new MenuItem (menuItemNames[i]));
	    if ((sepPosListPosition >= 0) &&
                   (separatorPositions[sepPosListPosition] -1 == i))
	    {
		m.addSeparator();
                if (separatorPositions.length -1 > sepPosListPosition)
		    sepPosListPosition++;
		else
		    sepPosListPosition = -1; //have reached end of list
	    }
	}

	return   m;
    }

    private Menu createCheckboxMenu()
    {
	Menu   m;

	m = new Menu (menuName);
	for (int i = 0; i < menuItemNames.length; i++)
	{
	    m.add (new CheckboxMenuItem (menuItemNames[i]));
	    if ((sepPosListPosition >= 0) &&
                    (separatorPositions[sepPosListPosition] -1 == i))
	    {
		m.addSeparator();
		sepPosListPosition++;
	    }
	}

	return   m;
    }

    private Menu createCheckboxGroupMenu()
    {
	Menu   m;

	m = new Menu (menuName);
	for (int i = 0; i < checkboxMIgroups.length; i++)
	{
	    Vector oneCheckboxGroupV = checkboxMIgroups[i];
	    Enumeration  nameListOfV = oneCheckboxGroupV.elements();
	    while (nameListOfV.hasMoreElements())
	    {
		CheckboxMenuItem  elt =
                            (CheckboxMenuItem)nameListOfV.nextElement();
		m.add (elt);
	    }
	    if ( !((i +1) == checkboxMIgroups.length) )
		// not the last group of menu items
		m.addSeparator();
	}

	return   m;
    }
}
