/* Copyright (C) 1996-1999 PLUS Group - University of Maryland

   This software is provided under the terms of the GNU General Public
   License Version 2, June 1991. See the file License.html for details.
   */
package  parka;

import   java.awt.Event;

/* Class to use with mouse events in any component
 */
public class  MouseHelper  extends Object
{
    Event  e;
    int    modifiers;

    MouseHelper (Event evt)
    {
	e = evt;
        modifiers = evt.modifiers;
    }

    // pressing mouse button 3  (shift, control ignored)
    //
    private boolean meta_only_down()
    {
	return  ( ((modifiers & Event.META_MASK) != 0) &&
                  ((modifiers & Event.ALT_MASK) == 0) );
    }

    // pressing mouse button 2  (shift, control ignored)
    //
    private boolean alt_only_down()
    {
	return  ( ((modifiers & Event.ALT_MASK) != 0)  &&
                  ((modifiers & Event.META_MASK) == 0) );
    }

    private boolean shift_or_control_also()
    {
        return  ( ((modifiers & Event.CTRL_MASK) != 0) ||
                  ((modifiers & Event.SHIFT_MASK) != 0) );
    }

/*  0 = not mouse event
    1 = mouse 1 button without shift key
    4 = mouse 1 button with    shift key
    2 = mouse 2 button
    3 = mouse 3 button
*/
    public static int which_mouse_button (Event evnt)
    {
        int  which_mouse;

         //Event.MOUSE_MOVE, Event.MOUSE_ENTER, and Event.MOUSE_EXIT
                // will not be accepted.

        if ((evnt.id == Event.MOUSE_DOWN) || (evnt.id == Event.MOUSE_UP) ||
               (evnt.id == Event.MOUSE_DRAG))
	{
	    MouseHelper  mh = new MouseHelper(evnt);

            if (mh.meta_only_down())
            {   // right mouse button or alt/option
    	        which_mouse = 3;
    	    }
            else  if (mh.alt_only_down())
            {   // middle mouse button or meta/command
    	        which_mouse = 2;
    	    }
    	    else  if (mh.shift_or_control_also())
    	        which_mouse = 4;
                      // '4' is button 1 with the shift or control key down
	    else
    	        which_mouse = 1;

	// DEBUG    System.out.println ("'which_mouse' == " + which_mouse);
	}
	else
	{
	    which_mouse = 0;
	    System.out.println ("Error: Mouse button looked for, but " +
                  "not a mouse event");
	}

	return  which_mouse;
    }
}
